library mi;

uses
  SysUtils, Windows, Classes, INIFiles;

{$I '..\types.inc'}
{$I '..\functions.inc'}
{$R MI+.RES}
{$R *.RES}

var
  CDDrive:Char;

////////////procedury pomocnicze/////////////////////////////
function GetCSV(const Text:string; const Num:Byte):string;
//pobiera pole z danych rozdzielonych przecinkami (CSV)
var
  A, Actual:Word;
  InText:Boolean;
begin
  InText:=False;
  Actual:=1;
  Result:='';
  for a:=1 to length(Text) do
  begin
    if Text[a]='"' then
      InText:=not InText
    else
      if (Text[a]=',') and (not Intext) then
        Inc(Actual)
      else
      if Actual=Num then
        Result:=Result+Text[a];
  end;
end;

///////////////Procedury eksportowane//////////////////////
procedure Info; stdcall;
begin
  MessageBox(0, 'Wtyczka obsugujca Magazyn Internet','Informacje o wtyczce',MB_OK);
end;

function PluginName:PChar; stdcall;
begin
  Result:='Magazyn Internet CD';
end;

function CDName:PChar; stdcall;
begin
  Result:='Magazyn Internet';
end;

function CanYouRegister:TCanYouRegisterResult; stdcall;
begin
  Result:=No;
  if   (FileExists(CDDrive+':\Data\About.txt')
    and FileExists(CDDrive+':\Data\Programy.dat')
    and FileExists(CDDrive+':\Micd.ico')
    and FileExists(CDDrive+':\Micd.exe')
    and FileExists(CDDrive+':\Autostrt.exe')
    and FileExists(CDDrive+':\Autorun.inf'))
    or
       (FileExists(CDDrive+':\Data\Programy.dat')//nowy
    and FileExists(CDDrive+':\Data\config.ini')
    and FileExists(CDDrive+':\Data\About.rtf')
    and FileExists(CDDrive+':\Data\Start.wav')
    and FileExists(CDDrive+':\Mi.exe')
//brak pliku na pycie 11/2003    and FileExists(CDDrive+':\Micd.ico')
    and FileExists(CDDrive+':\Autorun.inf'))
  then Result:=Yes;
end;

function RegisterCD(var CDStream, ItemStream:TMemoryStream;
  CDHeader:TCDHeader; ShowProgress:TShowProgress):TRegisterCDResult; stdcall;
var
  DataFile:TextFile;
  B:Byte;
  A:Word;
  Found:Boolean;
  INIFile:TINIFile;
  Row, CDTitle, Name, Description, Version:string;
  IH:TItemHeader;
begin
  Result:=Error;
  try
    CDStream.Position:=CDStream.Size; //ustawienie strumieni na koniec
    ItemStream.Position:=ItemStream.Size;

    if FileExists(CDDrive+':\Autostrt.exe') then //stara
    begin
      Assign(DataFile,CDDrive+':\Data\About.txt');
      Reset(DataFile);
      Readln(DataFile,Row);
      CDTitle:='Magazyn Internet';
      CDHeader.TitleLength:=Length(CDTitle);
      CDHeader.Year:=1900+StrToInt(Copy(Row, Pos('/',Row)+1,2));
      CDHeader.Month:=StrToInt(Copy(Row,13,Length(Row)-Pos('/',Row)-1));
      CDStream.Write(CDHeader, SizeOf(CDHeader));
      CDStream.Write(CDTitle[1],CDHeader.TitleLength);
      CloseFile(DataFile);

      AssignFile(DataFile, CDDrive+':\Data\Programy.dat');
      Reset(DataFile);
      B:=0;
      while not eof(DataFile) do //liczymy liczbe wierszy
      begin
        Readln(DataFile, Row);
        Inc(B);
      end;
      CloseFile(DataFile);

      Reset(DataFile);
      For A:=0 to B do
      begin
        Readln(DataFile,Row);
        if (Length(Row)>40) then
        begin
          if (GetCSV(Row,1)<>'Baza danych MICD')
            and (GetCSV(Row,1)<>'Lista polskich dostawcw usug internetowych')
            and (GetCSV(Row,1)<>'Lista polskich operatorw Internetu')
            and (GetCSV(Row,1)<>'Lista polskich dostawcw Internetu')
            and (GetCSV(Row,1)<>'Kurs HTML')
            and (GetCSV(Row,1)<>'Strony WWW - reklama')
          then
          begin
            Found:=False;
            if GetCSV(Row, 2)='Strony WWW' then
            begin
              Description:=GetCSV(Row, 9);
              Name:=GetCSV(Row, 1);
              IH.CDNumber:=CDHeader.CDNumber;
              IH.NameLength:=Length(Name);
              IH.DescriptionLength:=Length(Description);
              IH.License:=None;
              IH.CompanyLength:=0;
              IH.VersionLength:=0;
              ItemStream.Write(IH, SizeOf(IH));
              if IH.NameLength>0 then ItemStream.Write(Name[1], IH.NameLength);
              if IH.DescriptionLength>0 then ItemStream.Write(Description[1], IH.DescriptionLength);
              Found:=True;
            end;
            if (GetCSV(Row, 2)='Shareware') then //programy shareware
            begin
              ExtractNameVer(GetCSV(Row, 1), Name, Version);
              Description:=GetCSV(Row, 9);

              IH.CDNumber:=CDHeader.CDNumber;
              IH.NameLength:=Length(Name);
              IH.VersionLength:=Length(Version);
              IH.DescriptionLength:=Length(Description);
              IH.License:=Shareware;
              IH.CompanyLength:=0;

              ItemStream.Write(IH, SizeOf(IH));
              if IH.NameLength>0 then ItemStream.Write(Name[1], IH.NameLength);
              if IH.VersionLength>0 then ItemStream.Write(Version[1], IH.VersionLength);
              if IH.DescriptionLength>0 then ItemStream.Write(Description[1], IH.DescriptionLength);

              Found:=True;
            end;
            if (GetCSV(Row,2)='Ekstra') then //programy inne
            begin
              ExtractNameVer(GetCSV(Row, 1), Name, Version);
              Description:=GetCSV(Row,9);

              IH.CDNumber:=CDHeader.CDNumber;
              IH.NameLength:=Length(Name);
              IH.VersionLength:=Length(Version);
              IH.DescriptionLength:=Length(Description);
              IH.License:=None;
              IH.CompanyLength:=0;

              ItemStream.Write(IH,SizeOf(IH));
              if IH.NameLength>0 then ItemStream.Write(Name[1],IH.NameLength);
              if IH.VersionLength>0 then ItemStream.Write(Version[1],IH.VersionLength);
              if IH.DescriptionLength>0 then ItemStream.Write(Description[1],IH.DescriptionLength);

              Found:=True;
            end;
            if GetCSV(Row,2)='Gry' then  //inne
            begin
              Name:=GetCSV(Row,1);
              Description:=GetCSV(Row,9);

              IH.CDNumber:=CDHeader.CDNumber;
              IH.NameLength:=Length(Name);
              IH.DescriptionLength:=Length(Description);
              IH.License:=None;
              IH.CompanyLength:=0;
              IH.VersionLength:=0;

              ItemStream.Write(IH, SizeOf(IH));
              if IH.NameLength>0 then ItemStream.Write(Name[1], IH.NameLength);
              if IH.DescriptionLength>0 then ItemStream.Write(Description[1], IH.DescriptionLength);

              Found:=True;
            end;
            if (GetCSV(Row,2)='Strony WWW - reklama') then
            begin
              //Ignouj
              Found:=True;
            end;
            if not Found then
            begin
              ExtractNameVer(GetCSV(Row, 1), Name, Version);
              if Version<>'' then
              begin
                Description:=GetCSV(Row, 9);
                IH.CDNumber:=CDHeader.CDNumber;
                IH.NameLength:=Length(Name);
                IH.VersionLength:=Length(Version);
                IH.DescriptionLength:=Length(Description);
                IH.License:=None;
                IH.CompanyLength:=0;

                ItemStream.Write(IH, SizeOf(IH));
                if IH.NameLength>0 then ItemStream.Write(Name[1], IH.NameLength);
                if IH.VersionLength>0 then ItemStream.Write(Version[1], IH.VersionLength);
                if IH.DescriptionLength>0 then ItemStream.Write(Description[1], IH.DescriptionLength);
              end
              else
              begin
                Description:=GetCSV(Row, 9);
                IH.CDNumber:=CDHeader.CDNumber;
                IH.NameLength:=Length(Name);
                IH.DescriptionLength:=Length(Description);
                IH.License:=None;
                IH.CompanyLength:=0;
                IH.VersionLength:=0;

                ItemStream.Write(IH, SizeOf(IH));
                if IH.NameLength>0 then ItemStream.Write(Name[1], IH.NameLength);
                if IH.DescriptionLength>0 then ItemStream.Write(Description[1], IH.DescriptionLength);
              end;
            end;
          end;
        end;
        ShowProgress(100*a div b);
      end;
      CloseFile(DataFile);
    end

    else

    if FileExists(CDDrive+':\Mi.exe') then //nowa
    begin
      INIFile:=TINIFile.Create(CDDrive+':\Data\config.ini');
      CDTitle:=Copy(INIFile.Readstring('Ogolne','Nazwa',''),12,Length(INIFile.Readstring('Ogolne','Nazwa',''))-11);
      INIFile.Free;

      CDHeader.Year:=StrToInt(Copy(CDTitle, Pos('/',CDTitle)+1, 4));
      CDHeader.Month:=StrToInt(Copy(CDTitle,0, Pos('/',CDTitle)-1));
      CDTitle:='Magazyn Internet';
      CDHeader.TitleLength:=Length(CDTitle);

      CDStream.Write(CDHeader, SizeOf(CDHeader));
      CDStream.Write(CDTitle[1], CDHeader.TitleLength);

      AssignFile(DataFile,CDDrive+':\Data\Programy.dat');
      Reset(DataFile);
      B:=0;
      while not eof(DataFile) do //liczymy liczbe wierszy
      begin
        Readln(DataFile,Row);
        Inc(b);
      end;
      CloseFile(DataFile);
      Reset(DataFile);
      for a:=0 to b do
      begin
        ShowProgress(100*a div b);
        Readln(DataFile,Row);
        if (Length(Row)>30) then
        begin
          if (GetCSV(Row, 1)<>'Baza danych MICD') //ignorowane:
            and (GetCSV(Row, 1)<>'Lista polskich dostawcw usug internetowych')
            and (GetCSV(Row, 1)<>'Lista polskich operatorw Internetu')
            and (GetCSV(Row, 1)<>'Kurs HTML')
            and (GetCSV(Row, 1)<>'Kurs JavaScript')
          then
          begin
            Found:=False;
            if GetCSV(Row, 2)='Witryny' then
            begin
              Name:=GetCSV(Row, 1);
              Description:=GetCSV(Row, 9);
              IH.CDNumber:=CDHeader.CDNumber;
              IH.NameLength:=Length(Name);
              IH.DescriptionLength:=Length(Description);
              IH.License:=None;
              IH.CompanyLength:=0;
              IH.VersionLength:=0;

              ItemStream.Write(IH, SizeOf(IH));
              if IH.NameLength>0 then ItemStream.Write(Name[1],IH.NameLength);
              if IH.DescriptionLength>0 then ItemStream.Write(Description[1],IH.DescriptionLength);

              Found:=True;
            end;
            if (GetCSV(Row, 2)='Programy') or (GetCSV(Row, 2)='Ekstra') then
            begin
              ExtractNameVer(GetCSV(Row, 1), Name, Version);
              Description:=GetCSV(Row,9);

              IH.CDNumber:=CDHeader.CDNumber;
              IH.NameLength:=Length(Name);
              IH.VersionLength:=Length(Version);
              IH.DescriptionLength:=Length(Description);
              IH.License:=None;
              IH.CompanyLength:=0;

              ItemStream.Write(IH,SizeOf(IH));
              if IH.NameLength>0 then ItemStream.Write(Name[1],IH.NameLength);
              if IH.VersionLength>0 then ItemStream.Write(Version[1],IH.VersionLength);
              if IH.DescriptionLength>0 then ItemStream.Write(Description[1],IH.DescriptionLength);

              Found:=True;
            end;
            if (GetCSV(Row,2)='E-ziny') or (GetCSV(Row,2)='Demoscena') then
            begin
              //Ignouj
              Found:=True;
            end;
            if not Found then
            begin
              ExtractNameVer(GetCSV(Row,1), Name, Version);
              if Version<>'' then  //Ver<>'' czyli prawdopodobnie jaki program
              begin
                Description:=GetCSV(Row,9);

                IH.CDNumber:=CDHeader.CDNumber;
                IH.NameLength:=Length(Name);
                IH.VersionLength:=Length(Version);
                IH.DescriptionLength:=Length(Description);
                IH.License:=None;
                IH.CompanyLength:=0;

                ItemStream.Write(IH, SizeOf(IH));
                if IH.NameLength>0 then ItemStream.Write(Name[1],IH.NameLength);
                if IH.VersionLength>0 then ItemStream.Write(Version[1],IH.VersionLength);
                if IH.DescriptionLength>0 then ItemStream.Write(Description[1],IH.DescriptionLength);

                Found:=True;
              end;
            end;
            if not Found then //wszystko inne
            begin
              Name:=GetCSV(Row,1);
              Description:=GetCSV(Row,9);

              IH.CDNumber:=CDHeader.CDNumber;
              IH.NameLength:=Length(Name);
              IH.DescriptionLength:=Length(Description);
              IH.License:=None;
              IH.CompanyLength:=0;
              IH.VersionLength:=0;

              ItemStream.Write(IH, SizeOf(IH));
              if IH.NameLength>0 then ItemStream.Write(Name[1], IH.NameLength);
              if IH.DescriptionLength>0 then ItemStream.Write(Description[1], IH.DescriptionLength);
            end;
          end;
        end;
      end;
      CloseFile(DataFile);
    end;
    Result:=Registered;
  except
    MessageBox(0, 'Bd podczas rejestracji pyty. Prosz skontaktowac si z autorem.', nil, MB_OK);
  end;
end;

function InitializePlugin(const CDLetter:Char):Boolean;
begin
  CDDrive:=CDLetter;
  Result:=True;
end;

exports
  RegisterCD,
  CanYouRegister,
  PluginName,
  CDName,
  Info,
  InitializePlugin;
end.
