library pcwk;

uses
  Stdctrls, INIFiles, Windows, SysUtils,Classes;

{$I '..\types.inc'}
{$I '..\functions.inc'}
{$R PCWK+.RES}
{$R *.RES}

var
  CDDrive:Char;

////////////////Procedury eksportowane//////////////////////
procedure Info; stdcall;
begin
  MessageBox(0, 'Wtyczka do programu Wyszukiwarka'#13+'Obsuguje pyty magazynu PC World Komputer. WTYCZKA NIE DZIAA',
                'Informacje o wtyczce',MB_OK);
end;

function PluginName:PChar; stdcall;
begin
  Result:='PCWK[nie obsugiwane]';
end;

function CDName:PChar; stdcall;
begin
  Result:='PCWK';
end;

function CanYouRegister:TCanYouRegisterResult; stdcall;
begin
  Result:=No;
end;

function RegisterCD(var CDStream, ItemStream:TMemoryStream;
  CDHeader:TCDHeader; ShowProgress:TShowProgress):TRegisterCDResult; stdcall;
//gwna procedura rejestrujca pyt
var
  Row:string;
  IH:TItemHeader;
  CDTitle, Name, Description, Version, Cat, License:string;
  Bufor:array[0..Max_Path] of Char;
  MaxCompLength,FileSystemFlags:Cardinal;
  Serial:DWORD;
  TempMonth,TempYear:string;
  DataFile:TextFile;
  DataStream:TMemoryStream;
  Ch:Char;
  A, Lines:Word;
  Reg:array[0..999] of Boolean;
begin
  Result:=Error;
  try
    CDStream.Position:=CDStream.Size; //ustawienie strumieni na koniec
    ItemStream.Position:=ItemStream.Size;
    ItemStream.Position:=ItemStream.Size;
    ItemStream.Position:=ItemStream.Size;
    ShowProgress(0);

{      DataStream:=TMemoryStream.Create;
      DataStream.LoadFromFile(CDDrive+':\Browser\Chip.dat');
      try
        DataStream.Position:=DataStream.Size-25;
        SetLength(Row,25);
        DataStream.Read(Row[1], 25);
        while not(Row[1] in ['0'..'9']) do Delete(Row,1,1);
        while Pos(#9,Row)<>0 do Delete(Row, Length(Row), 1);
        CDHeader.Month:=StrToInt(Copy(Row,1,Pos('/',Row)-1));
        CDHeader.Year:=StrToInt(Copy(Row,Pos('/',Row)+1,Length(Row)-Pos('/',Row)));
        CDTitle:='K Ekspert';
        CDHeader.TitleLength:=Length(CDTitle);
        CDStream.Position:=CDStream.Size;
        CDStream.Write(CDHeader, SizeOf(CDHeader));
        CDStream.Write(CDTitle[1], CDHeader.TitleLength);

        DataStream.Position:=44;
        DataStream.Read(Ch,1);
        while DataStream.Size<>DataStream.Position do
        begin
          Row:='';
          while Ch<>#13 do
          begin
            Row:=Row+Ch;
            DataStream.Read(Ch,1);
          end;
          while ((Ch=#13) or (Ch=#10)) and (DataStream.Size<>DataStream.Position) do DataStream.Read(Ch,1);
          ShowProgress(100*DataStream.Position div DataStream.Size);
          if (GetItem(Row, 1)='root') or
             (GetItem(Row, 1)='hardware') or
             (GetItem(Row, 1)='chip') or
             (GetItem(Row, 1)='chip internet') or
             (GetItem(Row, 1)='software') or
             (GetItem(Row, 1)='internet') or
             (GetItem(Row, 1)='porady') or
             (StrToIntDef(GetItem(Row,0),1000)=1000) or //jeli nie liczba
             Reg[StrToInt(GetItem(Row,0))] //jeli ju zarejestrowany
             then Continue;

          Reg[StrToInt(GetItem(Row, 0))]:=True;
          ExtractNameVer(GetItem(Row, 1), Name, Version);
          Description:=GetItem(Row, 2);

          IH.CDNumber:=CDHeader.CDNumber;
          IH.NameLength:=Length(Name);
          IH.DescriptionLength:=Length(Description);
          IH.License:=None;
          IH.CompanyLength:=0;
          IH.VersionLength:=Length(Version);

          ItemStream.Position:=ItemStream.Size;
          ItemStream.Write(IH, SizeOf(IH));
          if IH.NameLength>0 then ItemStream.Write(Name[1], IH.NameLength);
          if IH.VersionLength>0 then ItemStream.Write(Version[1], IH.VersionLength);
          if IH.DescriptionLength>0 then ItemStream.Write(Description[1], IH.DescriptionLength);
        end;
      finally
        DataStream.Free;
      end;
    end
 }
    Result:=Manual;
  except
    MessageBox(0, 'Wystpi bd. Prosz skontaktowa si z autorem.',nil,MB_OK);
  end;
end;

exports
//  RegisterCD,
//  Cancel,
//  CanYouRegister,
//  PluginName,
//  CDName,
//  InitializePlugin,
  Info;
end.
