library software;

uses
  SysUtils, Stdctrls, INIFiles, Windows, Classes, ShellAPI;

{$I '..\types.inc'}
{$I '..\functions.inc'}
{$R Software+.RES}
{$R *.RES}

var
  CDDrive:Char;

procedure Info; stdcall;
begin
  MessageBox(0, 'Software CD Plugin','Informacje o...',MB_OK);
end;

function PluginName:PChar; stdcall;
begin
  //zwraca tekst ktry bdzie umieszczony w menu Plugins
  Result:='Software';
end;

function CDName:PChar; stdcall;
begin
  Result:='Software';
end;

function CanYouRegister:TCanYouRegisterResult; stdcall;
var
  Bufor:array[0..Max_Path] of Char;
  MaxCompLength,FileSystemFlags:Cardinal;
  Serial:DWORD;
begin
  Result:=No;
  GetVolumeInformation(PChar(CDDrive+':\'),Bufor,SizeOf(Bufor),@Serial,MaxCompLength,FileSystemFlags,nil,0);
  if Copy(StrPas(Bufor),1,8)='Software' then Result:=OnlyManual;
end;

function RegisterCD(var CDStream, ItemStream:TMemoryStream;
  CDHeader:TCDHeader; ShowProgress:TShowProgress):TRegisterCDResult; stdcall;
var
  Bufor:array[0..Max_Path] of Char;
  MaxCompLength,FileSystemFlags:Cardinal;
  Serial:DWORD;
  CDTitle:string;
begin
  CDStream.Position:=CDStream.Size; //ustawienie strumieni na koniec
  ItemStream.Position:=ItemStream.Size;
  ItemStream.Position:=ItemStream.Size;
  ItemStream.Position:=ItemStream.Size;

  ShowProgress(0);
  GetVolumeInformation(PChar(CDDrive+':\'),Bufor,SizeOf(Bufor),@Serial,MaxCompLength,FileSystemFlags,nil,0);
  CDTitle:='Software';
  CDHeader.TitleLength:=Length(CDTitle);
  CDHeader.Year:=1900+StrToInt(Copy(StrPas(Bufor),13,2));
  CDHeader.Month:=StrToInt(Copy(StrPas(Bufor),10,2));

  CDStream.Write(CDHeader, SizeOf(CDHeader));
  CDStream.Write(CDTitle[1],CDHeader.TitleLength);
  Result:=Manual;
  if MessageBox(0, 'Pyta zawiera informacje o zawartoci, '+
                    'ale nie mog by one wykorzystane do automatycznej '+
                    'rejestracji.'+#13#13+'Czy otworzy plik zawierajcy te informacje ?',
                    'Uwaga',MB_YESNO) = IDYES then
    ShellExecute(GetDesktopWindow,'open',PChar(CDDrive+':\index.htm'),nil,nil,SW_Show);
end;

function InitializePlugin(const CDLetter:Char):Boolean;
begin
  CDDrive:=CDLetter;
  Result:=True;
end;

exports
  RegisterCD,
  CanYouRegister,
  PluginName,
  CDName,
  Info,
  InitializePlugin;
end.
