//Ten plik zawiera definicje rekordw i funkcji uywanych przez dodatkowe
//wtyczki do aplikacji Wyszukiwarka

//Pytania, sugestie...
//dkc@o2.pl
//www.cieszak.prv.pl
//cieszak.private.pl

type
  //zmienna do przechowywanie hash'a utworzonego zgodnie z algorytmem MD4
  TMD4Hash=array[0..15] of LongWord;

  //Licencja
  TLicense=(None, Shareware, Freeware, Demo, Full, Evaluation, GPL, Adware);

  //rekord zawierajcy informacje o zarejestrowanej pycie,
  //CDStream jest wypeniony takimi rekordami uzupenionymi o dane tekstowe
  TCDHeader=packed record
    CDNumber:   Word;
    Month:      Byte;
    Year:       Word;
    DiskLabel:  string[14];
    Serial:     LongWord;
    TitleLength:Byte;
  end;

  //zawiera informacje o zarejestrowanych programach, ItemStream jest wypeniony
  //tymi rekordami uzupenionymi o dane tekstowe
  TItemHeader=packed record
    CDNumber:         Word;
    License:          TLicense;
    NameLength:       Byte;
    CompanyLength:    Byte;
    VersionLength:    Byte;
    DescriptionLength:Word;
  end;

  //rezultat wykonania funkcji RegisterCD (prby rejestrowania pyty)
  TRegisterCDResult=(Registered, Manual, Error);

  //rezultat wywoania funkcji CanYouRegister
  TCanYouRegisterResult=(Yes, No, OnlyManual);

  //funkcja wywoywana przez wtyczk w celu aktualizacji
  //wartoi paska postpu (RegisteringForm.ProgressBar)
  TShowProgress=function(const Pos:Byte):Boolean; stdcall;

{funkcje, zawarte we wtyczkach wywoywane przez pogram gwny}

  //inicjalizacja wtyczki
  TInitializePlugin=function(const CDLetter:Char):Boolean; stdcall;

  //rejestrowanie pyty
  TRegisterCD=function(var CDStream, ItemStream:TMemoryStream;
    CDHeader:TCDHeader; ShowProgress:TShowProgress):TRegisterCDResult; stdcall;

  //funkcja zwraca informacje o moliwoci rejestracji pyty znajdujcej si
  //aktualnie w napdzie CD-ROM
  TCanYouRegister=function:TCanYouRegisterResult; stdcall;

  //funkcja zwraca nazw wtyczki
  TPluginName=function:PChar; stdcall;

  //funkcja zwraca nazw pyty woonej do napdu CD-ROM
  TCDName=function:PChar; stdcall;

  //funkcja zwraca informacj: czy maj by zamykane wszystkie aplikacje
  //uruchamiane z pyty
  TKillApp=function:Boolean; stdcall;

  //procedura wywoywana przez program gdy uytkownik kliknie pozycj menu
  //odpowiadajc danej wtyczce, moe suy do wywielenia informacji
  //o wtyczce lub konfiguracji wtyczki
  //przypisywana do zdarzenia OnClick
  TInfo=TNotifyEvent; //procedure (Sender:TObject)of Object;



const
  //miejsce w kluczu HKEY_LOCAL_MACHINE dla programu
  RegPath='Software\DKC Software\Wyszukiwarka\';
  //miejsce w kluczu HKEY_LOCAL_MACHINE dla wtyczek
  RegPluginPath='Software\DKC Software\Wyszukiwarka\Plugins\';
  //nazwa folderu z danymi
  DataFolder='Dane';



